// v싅FAN(PC98) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*8*154];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size) {
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos {
	int trk;
	int sec;
	int ofs;
	int size;
};

int main(int argc, char *argv[]) {

	// ȃf[^̈ʒu(2HD)
	struct fpos mdh[] = {
		 { 0x46, 0x01, 0x0000, 0x0400 },	// v싅ĺI
		 { 0x46, 0x05, 0x0000, 0x0800 },	// HOMERUN / Sweet Sweet Sports
		 { 0x47, 0x01, 0x0000, 0x0800 },	// HOMERUN / Passionative Game
		 { 0x47, 0x05, 0x0000, 0x0800 },	// HOMERUN / Dream Ball Dance
		 { 0x48, 0x01, 0x0000, 0x0800 },	// HOMERUN / ܂Diamonds
		 { 0x48, 0x05, 0x0000, 0x0800 },	// jꂽ
		 { 0x49, 0x01, 0x0000, 0x0800 },	// Ċ̏߂
		 { 0x49, 0x05, 0x0000, 0x0c00 },	// HAPPY TURN 1
		 { 0x4a, 0x01, 0x0000, 0x1000 },	// HAPPY TURN 2
//		 { 0x7c, 0x02, 0x02c0, 0x05e0 },	// Ċ̏߂
//		 { 0x89, 0x08, 0x0160, 0x0640 },	// jꂽ
		 { 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	// ȃf[^̈ʒu(2DD)
	struct fpos mdd[] = {
		 { 0x6e, 0x01, 0x0000, 0x0400 },	// v싅ĺI
		 { 0x6f, 0x01, 0x0000, 0x0800 },	// HOMERUN / Sweet Sweet Sports
		 { 0x70, 0x01, 0x0000, 0x0800 },	// HOMERUN / Passionative Game
		 { 0x71, 0x01, 0x0000, 0x0800 },	// HOMERUN / Dream Ball Dance
		 { 0x72, 0x01, 0x0000, 0x0800 },	// HOMERUN / ܂Diamonds
		 { 0x73, 0x01, 0x0000, 0x0800 },	// jꂽ
		 { 0x74, 0x01, 0x0000, 0x0800 },	// Ċ̏߂
		 { 0x75, 0x01, 0x0000, 0x0c00 },	// HAPPY TURN 1
		 { 0x76, 0x01, 0x0000, 0x1000 },	// HAPPY TURN 2
//		 { 0x4f, 0x01, 0x02c0, 0x05e0 },	// Ċ̏߂
//		 { 0x5b, 0x05, 0x0160, 0x0640 },	// jꂽ
		 { 0x00, 0x00, 0x0000, 0x0000 },	// End of Data
	};

	char fname[FILENAME_MAX];
	int i;

	if (argc<2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	disk.SelectDisk(0);

	switch(disk.GetDiskType()) {

	case disk.TYPE_2HD:
		printf("2HD Version\n");
		disk.SetRecordRange(0x01,0x08);
		// hCoق
		fcut("PROG",  0x08, 0x04, 0x00, 0x01, 0x03, 0x0000, 0xe000);
		// ȃf[^
		for (i=0; mdh[i].sec; i++) {
			sprintf(fname,"MUS%02d",i);
			fcut(fname, mdh[i].trk, mdh[i].trk>>1, mdh[i].trk&1, mdh[i].sec, 0x03, mdh[i].ofs, mdh[i].size);
//			fcut(fname, mdh[i].trk, mdh[i].trk>>1, mdh[i].trk&1, mdh[i].sec, 0x03, mdh[i].ofs, 0x2000);
		}
		break;

	case disk.TYPE_2DD:
		printf("2DD Version\n");
		disk.SetRecordRange(0x01,0x05);
		fcut("PROG",  0x0a, 0x05, 0x00, 0x01, 0x03, 0x0000, 0xd800);
		for (i=0; mdd[i].sec; i++) {
			sprintf(fname,"MUS%02d",i);
			fcut(fname, mdd[i].trk, mdd[i].trk>>1, mdd[i].trk&1, mdd[i].sec, 0x03, mdd[i].ofs, mdd[i].size);
//			fcut(fname, mdd[i].trk, mdd[i].trk>>1, mdd[i].trk&1, mdd[i].sec, 0x03, mdd[i].ofs, 0x1400);
		}
		break;

	default:
		break;

	}

	return 0;
}

